﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;
using Infragistics.Documents.Excel;
using System.IO;
using System.Diagnostics;
using System.ComponentModel;
using System.Runtime.InteropServices.Automation;
using System.Reflection;
using System.Linq;


namespace XamGridDataBinding
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        // Create workbook
        Workbook newWorkBook = new Workbook();
        private void button1_Click(object sender, RoutedEventArgs e)
        {
               
             // Set up background worker object & hook up handlers  

                 BackgroundWorker bgWorker;  

                bgWorker = new BackgroundWorker();  

                bgWorker.DoWork += new DoWorkEventHandler(bgWorker_DoWork);  

                bgWorker.RunWorkerCompleted += new RunWorkerCompletedEventHandler(bgWorker_RunWorkerCompleted);   

                bgWorker.RunWorkerAsync(newWorkBook);

                //Create Save File Dialog
                SaveFileDialog savefileDialog = new SaveFileDialog { Filter = "Excel files|*.xls", DefaultExt = "xls" };

                // Display the dialog. If the user selects a file of the correct format 
                // and clicks Save in the dialog, save the file using the Save method of the Workbook object.
                if (savefileDialog.ShowDialog() == true)
                {
                    Stream stream = savefileDialog.OpenFile();
                    newWorkBook.Save(stream);
                    stream.Close();
                }
        }

        void bgWorker_DoWork(object sender, DoWorkEventArgs e)
        {
            Workbook workbook1 = (Workbook)e.Argument;
            // Add worksheet
            Worksheet worksheet1 = workbook1.Worksheets.Add("Sample Worksheet1");

            WorksheetRow worksheetRow;

            int Index = 1;
            
            foreach (Product v_product in DataClass.Products)
            {
                worksheetRow = worksheet1.Rows[Index];
                Index++;
                worksheetRow.Cells[0].Value = v_product.ProductID;
                worksheetRow.Cells[1].Value = v_product.ProductName;
                worksheetRow.Cells[2].Value = v_product.CategoryID;
                worksheetRow.Cells[3].Value = v_product.QuantityPerUnit;
                worksheetRow.Cells[4].Value = v_product.UnitPrice;
                worksheetRow.Cells[5].Value = v_product.UnitsInStock;
                worksheetRow.Cells[6].Value = v_product.UnitsOnOrder;
                worksheetRow.Cells[7].Value = v_product.ReorderLevel;
                worksheetRow.Cells[8].Value = v_product.Discontinued;
            }

          

          //  e.Result = workbook1;
        }

        void bgWorker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            if (e.Error != null)
            {
                MessageBox.Show(e.Error.Message);
            }
            else
            {
                //newWorkBook = (Workbook)e.Result;
            }

        }


        //void CreateWorkSheet()
        //{

        //    //foreach (Row gridRow in this.xamGrid1.Rows)
        //    //{
        //    //    worksheetRow = worksheet1.Rows[gridRow.Index + 1];

        //    //    for (int columnIndex = 0; columnIndex < this.xamGrid1.Columns.Count; columnIndex++)
        //    //    {
        //    //        // Set Excell cell value to xamGrid's cell value cell by cell
        //    //        worksheetRow.Cells[columnIndex].Value = gridRow.Cells[columnIndex].Value;

        //    //        /* Set header appearance and text */
        //    //        if (gridRow.Index == 0)
        //    //        {
        //    //            worksheetCell = worksheet1.Rows[0].Cells[columnIndex];

        //    //            gridColumn = this.xamGrid1.Columns[columnIndex] as Column;

        //    //            //worksheet1.Columns[columnIndex].Width = (int)col.Width.Value;
        //    //            // Set header cell color and and borders
        //    //            worksheetCell.CellFormat.FillPatternForegroundColor = Colors.LightGray;
        //    //            worksheetCell.CellFormat.LeftBorderColor = Color.FromArgb(0, 178, 178, 178);
        //    //            worksheetCell.CellFormat.RightBorderColor = Color.FromArgb(0, 178, 178, 178);

        //    //            // Set Excel header text to key of column
        //    //            worksheetCell.Value = gridColumn.Key;
        //    //        }
        //    //    }
        //    //}
        //}

    }
}
